<?php

namespace Teknisa\DF\Modules\Saida\Controllers;

use Zeedhi\Framework\DTO;
use Zeedhi\Framework\Report\ReportService;
use Teknisa\GER\Services\SMTPService;

class BirtReportController extends \Zeedhi\Framework\Controller\Report {

    public function __construct(ReportService $reportService) {
        parent::__construct($reportService);
    }

    /** @var array  */
    protected $reportMapping = array (
        'espelho_nfse_rio' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLANCTONF' => 'P_NRLANCTONF',
                'CDFILIAL'   => 'P_CDFILIAL',
                'NRORG'      => 'P_NRORG'
            ),
        ),
        'espelho_nfse' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLANCTONF' => 'P_NRLANCTONF',
                'CDFILIAL'   => 'P_CDFILIAL',
                'NRORG'      => 'P_NRORG'
            ),
        ),
        'espelho_nfse_teknisa' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLANCTONF' => 'P_NRLANCTONF',
                'CDFILIAL'   => 'P_CDFILIAL',
                'NRORG'      => 'P_NRORG'
            ),
        ),
        // tulio - como o arquivo utiliza desse modelo, a montagem do birtReporter só é possível se o modelo estiver inicializado aqui
        'DFE13000' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLANCTONF' => 'P_NRLANCTONF',
                'CDFILIAL'   => 'P_CDFILIAL',
                'NRORG'      => 'P_NRORG'
            ),
        ),
         'espelho_nfse_sapore' => array (
            'strategy' => 'BIRT',
            'parameterMapping' => array (
                'NRLANCTONF' => 'P_NRLANCTONF',
                'CDFILIAL'   => 'P_CDFILIAL',
                'NRORG'      => 'P_NRORG'
            ),
        ),'Modelo_Banrisul' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELO_SICREDI' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),


        'ModBolComp_Santander' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELOBOL_BRADESCO' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBol_Santander' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolComp' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'modelobolcomp_banrisul' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'MODELOBOLCOMITAU' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolComp_SICOOB' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolCompCaixa' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolCompPort' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolCompSafra' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),

        'ModeloBolComp_Santander' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'CDFILIAL'  => 'CDFILIAL',
                        'NRLANBOLREC'   => 'NRLANBOLREC',
                        'NRORG'   => 'NRORG'
                    ),
            ),
        'DFE51000' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'P_NRACESSONFE'     => 'P_NRACESSONFE',
                        'P_CDFORNECED'      => 'P_CDFORNECED',
                        'P_CDSERIE'         => 'P_CDSERIE',
                        'P_NRNOTAFISC'      => 'P_NRNOTAFISC',
                        'P_NRORG' => 'P_NRORG'
                    ),
            ),
        'DFE51001' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'P_NRACESSONFE'     => 'P_NRACESSONFE',
                        'P_CDFORNECED'      => 'P_CDFORNECED',
                        'P_CDSERIE'         => 'P_CDSERIE',
                        'P_NRNOTAFISC'      => 'P_NRNOTAFISC',
                        'P_NMARQUIVO'       => 'P_NMARQUIVO',
                        'P_DSINCONSISTENCIA'=> 'P_DSINCONSISTENCIA',
                        'P_NRORG' => 'P_NRORG'
                    ),
            ),
        'DFE51002' =>
            array (
                'strategy' => 'BIRT',
                'parameterMapping' =>
                    array (
                        'P_NRACESSONFE'     => 'P_NRACESSONFE',
                        'P_DSINCONSISTENCIA'=> 'P_DSINCONSISTENCIA',
                        'P_NRORG' => 'P_NRORG'
                    ),
            ),
    );
    
    public function setReportMapping($reportMapping) {
        $this->reportMapping = $reportMapping;
    }
    
}