<?php

namespace Teknisa\DF\Services;

use Teknisa\Libs\Util\Environment;
use Teknisa\DF\Modules\Entrada\Factories\Dfe71000SincronizacaoCTEFactory;
use Teknisa\DF\Modules\Entrada\Factories\ManifestacaoDestinatarioFactory;
use Teknisa\DF\Factories\Ger40100IntegracaoViaEmailFactory;

class CallServiceIntegraViaEmail {
    
    protected $sincronizacaoCTEFactory;
    protected $manifestacaoDestinatarioFactory;
    protected $ger40100IntegracaoViaEmailFactory;
    protected $environment;
    protected $host;
    protected $usuario;
    protected $senha;
    protected $ssl;
    protected $tipoSSL;
    protected $row;
    protected $caminhoDir;
    protected $arrExtensoes;
    protected $uids;
    protected $mbox;
    protected $estrutura;
    protected $nomeAnexo;
    protected $extensao;
    protected $dados;
    protected $dir_file;
    protected $arq;
    protected $retorno;
    
    
    public function __construct(Dfe71000SincronizacaoCTEFactory $sincronizacaoCTEFactory, $manifestacaoDestinatarioFactory, $ger40100IntegracaoViaEmailFactory, $environment) {
        $this->sincronizacaoCTEFactory = $sincronizacaoCTEFactory;
        $this->manifestacaoDestinatarioFactory = $manifestacaoDestinatarioFactory;
        $this->ger40100IntegracaoViaEmailFactory = $ger40100IntegracaoViaEmailFactory;
        $this->environment          = $environment;
        set_time_limit(0);
    }
    
    public function conexaoSMTP($host, $usuario, $senha, $ssl) {
        try {
            if($ssl == "S")
                $tipoSSL = ":993/imap/ssl}INBOX";
            else
                $tipoSSL = ":143/novalidate-cert}INBOX";
            return $mbox = imap_open("{".$host.$tipoSSL, $usuario, $senha);
        }  catch(\Exception $e) {
            throw $e;
        }
        //return $mbox;
    }
    
    public function VerificaEmail($row, $caminhoDir) {
        $host = $row["DSSERVEMAIL"];
        $usuario = $row["DSLOGINEMAIL"];
        $senha = $row["CDSENHAEMAIL"];
        $arrExtensoes = explode(",",strtolower($row["DSARQEXTENSAO"]));
        $ssl = $row["IDUTSSLEMAIL"];
        try {
            $mbox = $this->conexaoSMTP($host, $usuario, $senha, $ssl);
            //var_dump($mbox);
            $uids = imap_search($mbox, 'UNSEEN');
            if(is_array($uids))
                foreach ($uids as $uid) {
                    $estrutura = imap_fetchstructure($mbox, $uid);
                    
                    if($estrutura->subtype != 'HTML'){
                        if(($estrutura->parts[0]->subtype) == 'ALTERNATIVE' || ($estrutura->parts[0]->subtype) == 'PLAIN') {
                            
                           for($ind=1; $ind<count($estrutura->parts); $ind++){
                                if($estrutura->parts[$ind]->subtype != 'HTML') {
                                    if($estrutura->parts[$ind]->disposition) {
                                        $nomeAnexo = $estrutura->parts[$ind]->dparameters[0]->value;
                                        $extensao = strtolower(pathinfo($nomeAnexo, PATHINFO_EXTENSION));
                                        foreach($arrExtensoes as $ext){
                                            if(TRIM($ext) == TRIM($extensao)){
                                                $dados = imap_base64(imap_fetchbody($mbox, $uid, $ind+1));
                                    		    $xml                    = new \DOMDocument();
                                                $xml->preservWhiteSpace = false; //elimina espacos em branco
                                                $xml->formatOutput      = false;
                                                $xml->loadXML($dados);
                                                $protNFe = $xml->getElementsByTagName('protNFe')->item(0);
                                    		    
                                    			if($protNFe) {
                                    			    $chave = $protNFe->getElementsByTagName('infProt')->item(0)->getElementsByTagName('chNFe')->item(0)->nodeValue;
                                    			    $tpAmb = $protNFe->getElementsByTagName('infProt')->item(0)->getElementsByTagName('tpAmb')->item(0)->nodeValue;
                                    			}
                                    			else {
                                                    $protCTe = $xml->getElementsByTagName('protCTe')->item(0);
                                            		if($protCTe) {
                                            		    $chaveCTe = $protCTe->getElementsByTagName('infProt')->item(0)->getElementsByTagName('chCTe')->item(0)->nodeValue;
                                    			        $tpAmb = $protCTe->getElementsByTagName('infProt')->item(0)->getElementsByTagName('tpAmb')->item(0)->nodeValue;
                                            		}
                                    			}
                                            //Nfe
                                                if($protNFe) {
            			                            if($chave) {
                                			            if($this->environment->getNrOrgTrab() != 1) {
                                			                if(!isset($this->manifestacaoDestinatarioFactory->existeNotaRelac($chave)[0])) {
                                                			    $this->ger40100IntegracaoViaEmailFactory->zGravaFile($tpAmb, $chave.'.xml', $dados, 'importar/', $chave);
                                                                $retorno = "Arquivos inseridos com sucesso em \n".$usuario." \n";
                                			                }
                                            			}
                                            			else {
                                                            $dir_file = $caminhoDir[0]["DSDIRIMPARQXML"].$nomeAnexo;
                                                            $arq = fopen($dir_file,"w"); 
                                                            fwrite($arq, $dados); 
                                                            fclose($arq);
                                                            if (file_exists($dir_file)) {
                                                                $retorno = "Arquivos inseridos com sucesso em \n".$usuario." \n";
                                                            }
                                            			}
            			                            }
                                                }
                                            //CTe
                                    			elseif($protCTe){
            			                            if($chaveCTe) {
                                                        if($this->environment->getNrOrgTrab() != 1) {
                                                            if(!isset($this->sincronizacaoCTEFactory->existeNotaRelac($chaveCTe)[0])) {
                                                    			    $this->ger40100IntegracaoViaEmailFactory->zGravaFile($tpAmb, $chaveCTe.'.xml', $dados, 'importar/', $chaveCTe);
                                                                    $retorno = "Arquivos inseridos com sucesso em \n".$usuario." \n";
                                                            }
                                            			}
                                            			else {
                                                            $dir_file = $caminhoDir[0]["DSDIRIMPARQXML"].$nomeAnexo;
                                                            $arq = fopen($dir_file,"w"); 
                                                            fwrite($arq, $dados); 
                                                            fclose($arq);
                                                            if (file_exists($dir_file)) {
                                                                $retorno = "Arquivos inseridos com sucesso em \n".$usuario." \n";
                                                            }
                                            			}
            			                            }
                                    			}
                                            }
                                        }
                                    }
                                }
                            }
                        }
                    }
                    imap_setflag_full($mbox, $uid, "\\Seen"); 
                }
            if(!(isset($retorno))) {
                $retorno = "Não existe registro para ser importado em \n ".$usuario." \n";
            }
            imap_close($mbox);
        } catch(\Exception $e) {
            throw $e;
        }
        return $retorno;
    }
    
    private function converteXmlParaArray($stringXml) {
        $xml = simplexml_load_string($stringXml,null,LIBXML_NOCDATA);
        $json = json_encode($xml);
        $array = json_decode($json,TRUE);
        return $array;
    }
}
